/*
   Projet IFT763 : Objets volant avec Verlet / Contraintes

   (C) Eric Beaudry 2004.
   Eric.Beaudry@USherbrooke.ca
   http://siela.dmi.usherb.ca/~eric/

   Universit de Sherbrooke
   Facult des Sciences
   Dpartement d'Informatique

*/

#if !defined(__DRAPEAU_H__)
#define __DRAPEAU_H__


#include "object.h"
#include "physic.h"

class Drapeau : public Object{
   public:
      Drapeau(int resw, int resh, double x, double y, double z, double w, double h, double m);
      virtual ~Drapeau();

      virtual void  renderGL() const;
      void          registerInSimulator(PhysicSimulatorEuler* sim, double tension=500, double damper=0.1);
      void          registerInSimulator(PhysicSimulatorVerlet* sim);

      Particule&    get(int x, int y) { return particules[x+y*resW];}

   protected:
      Particule*    particules;
      Vector*       normals;
      int           resW, resH;
};


#endif
