/*
   Projet IFT763 : Objets volant avec Verlet / Contraintes

   (C) Eric Beaudry 2004.
   Eric.Beaudry@USherbrooke.ca
   http://planiart.usherbrooke.ca/~eric/

   Universit de Sherbrooke
   Facult des Sciences
   Dpartement d'Informatique

*/


#if !defined(__KITE_H__)
#define __KITE_H__

#include "object.h"
#include "physic.h"

class Kite : public Object {
  public:
      Kite(const Point& ropeattach, const Point& position0, const Vector& width, const Vector& height,
           double masskite, int resolution=4, int roperes=10);
      virtual ~Kite();

      void             registerInSimulator(PhysicSimulatorVerlet* sim);

      Point&           getPos() const { return partsKeel[0].pos; }

      virtual void     renderGL() const;


  protected:

      int              resolution; // Resolution is number of Stick by side of Kite
      int              resKeel;
      int              keel1, keel2;
      int              resRope;    // Resolution is number of Stick in the rope
      int              nbPartsKiteMain;
      int              nbPartsKiteKeel;

      Particule*       partsKite;
      Particule*       partsKeel;
      Particule*       partsRope;

      Particule        haut, bas;

    // For display...
    Vector*                normalsKite;  // Vecteurs normaux
    void                   computeNormals();
};


#endif
