/*
   Projet IFT763 : Objets volant avec Verlet / Contraintes

   (C) Eric Beaudry 2004.
   Eric.Beaudry@USherbrooke.ca
   http://planiart.usherbrooke.ca/~eric/

   Universit de Sherbrooke
   Facult des Sciences
   Dpartement d'Informatique

*/

#include <GL/glut.h>
#include <iostream>

#include "displayglut.h"
#include "drapeau.h"
#include "kite.h"
#include "terrain.h"
#include "timer.h"


Terrain2*                 terrain;
Kite*                     kite;
Drapeau*                  drapeau;
PhysicSimulatorVerlet*    simulator;

Timer                     timer;

void idle(){
   int n = timer.getNbStepToDo();
   if(n>0){
      for(int i=0;i<n;i++){
         simulator->iter();
      }
      Point pos = kite->getPos(); //kite->getPos();
      setPos(pos.x, pos.y, pos.z);
      //std::cout << "Step : " << step << std::endl;
      glutPostRedisplay();
   }else{
      //timer.waitUnitNextStep();
   }
}

int main(int argc, char** argv){

   terrain = new Terrain2();
   kite = new Kite(Point(0, -10, 0), Point(0, 0, 5), Vector(4, 0, 0), Vector(0, 2, -0.5), 2.2, 14, 14);
   drapeau = new Drapeau(20, 12, 0, 0, 2.5, 1, 0.6, 0.0250);
   simulator = new PhysicSimulatorVerlet();
   simulator->setWind(Vector(0, 8, 0));

   kite->registerInSimulator(simulator);
   //drapeau->registerInSimulator(simulator);

   addObject(terrain);
   //addObject(drapeau);
   addObject(kite);
   //showPhysicSim(simulator);
   createGlut(&argc, argv);
   glutIdleFunc(idle);
   simulator->init();
   timer.reset();
   glutMainLoop();

   delete terrain;
   delete kite;
   //delete drapeau2;
   delete simulator;

   return 0;
}

